Name:		cmph
Version:	2.0
Release:	1%{?dist}
Summary:	C Minimal Perfect Hashing Library

Group:		Development/Libraries
License:	LGPL or MPL 1.1
URL:		http://cmph.sourceforge.net/
Source0:	http://downloads.sourceforge.net/cmph/%{name}-%{version}.tar.gz
Requires:	%{name}-lib%{?_isa} = %{version}-%{release}

%description
The CMPH Library encapsulates the newest and more efficient algorithms in an 
easy-to-use, production-quality, fast API. The library was designed to work
with big entries that cannot fit in the main memory. It has been used
successfully for constructing minimal perfect hash functions for sets with
more than 100 million of keys, and we intend to expand this number to the
order of billion of keys. Although there is a lack of similar libraries, we 
can point out some of the distinguishable features of the CMPH Library:

- Fast.
- Space-efficient with main memory usage carefully documented.
- The best modern algorithms are available (or at least scheduled for 
  implementation :-)).
- Works with in-disk key sets through of using the adapter pattern.
- Serialization of hash functions.
- Portable C code (currently works on GNU/Linux and WIN32 and is reported to 
  work in OpenBSD and Solaris).
- Object oriented implementation.
- Easily extensible.
- Well encapsulated API aiming binary compatibility through releases.
- Free Software.


%package lib
Summary:	Library files for cmph
Group:		Development/Libraries

%description lib
The CMPH Library encapsulates the newest and more efficient algorithms in an
easy-to-use, production-quality, fast API. The library was designed to work
with big entries that cannot fit in the main memory. It has been used
successfully for constructing minimal perfect hash functions for sets with
more than 100 million of keys, and we intend to expand this number to the
order of billion of keys. Although there is a lack of similar libraries, we
can point out some of the distinguishable features of the CMPH Library:

- Fast.
- Space-efficient with main memory usage carefully documented.
- The best modern algorithms are available (or at least scheduled for
  implementation :-)).
- Works with in-disk key sets through of using the adapter pattern.
- Serialization of hash functions.
- Portable C code (currently works on GNU/Linux and WIN32 and is reported to
  work in OpenBSD and Solaris).
- Object oriented implementation.
- Easily extensible.
- Well encapsulated API aiming binary compatibility through releases.
- Free Software.

This rpm contains only the library files.

%package devel
Summary: 	Development files for cmph
Group:		Development/Libraries
Requires:	%{name}-lib%{?_isa} = %{version}-%{release}

%description devel
Development files for cmph.

%package static
Summary: 	Static cmph library
Group:		Development/Libraries
Requires:	%{name}-devel%{?_isa} = %{version}-%{release}

%description static
Static cmph library.

%prep
%setup -q


%build
%configure
make %{?_smp_mflags}


%install
make install DESTDIR=%{buildroot}
rm -f %{buildroot}%{_libdir}/*.la

%files
%{_bindir}/cmph
%{_mandir}/man1/cmph.1*

%files lib
%doc NEWS AUTHORS LGPL-2 MPL-1.1
%{_libdir}/libcmph.so.0*

%files devel
%doc examples
%{_includedir}/*.h
%{_libdir}/libcmph.so
%{_libdir}/pkgconfig/cmph.pc

%files static
%{_libdir}/libcmph.a

%changelog
* Tue Jan 2 2018 Josko Plazonic <plazonic@princeton.edu>
- initial build
